import { Flex } from 'antd';
import { SearchProps } from 'antd/lib/input';
import Search from 'antd/lib/input/Search';
import Paragraph from 'antd/lib/typography/Paragraph';
import React from 'react';


const Feature: React.FC = () => {

    const onSearch: SearchProps['onSearch'] = (value, _e, info) => console.log(info?.source, value);
    

    return (
        <>
            <Flex gap="large" vertical style={{ height: "100%", margin: "10px" }} justify="space-between" align="center" >

                <Search size="large" placeholder="input search text" onSearch={onSearch} style={{ width: "30%" }} />
              
                <Flex vertical>
                    
                    <Paragraph>
                        In the process of internal desktop applications development, many different design specs and
                        implementations would be involved, which might cause designers and developers difficulties and
                        duplication and reduce the efficiency of development.
                    </Paragraph>



                </Flex>
            </Flex>
        </>
    )
};

export default Feature;